---
title: XRSession.requestReferenceSpace()
slug: Web/API/XRSession/requestReferenceSpace
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Method
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRSession
  - requestReferenceSpace
  - space
  - tracking
---
<p>{{APIRef("WebXR")}}{{Draft}}{{SecureContext_Header}}</p>

<p class="summary"><span class="seoSummary">The <strong><code>requestReferenceSpace()</code></strong> method of the {{DOMxRef("XRSession")}} interface returns a {{JSxRef("promise")}} that resolves with an instance of either {{DOMxRef("XRReferenceSpace")}} or {{DOMxRef("XRBoundedReferenceSpace")}} as appropriate given the type of reference space requested.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>refSpacePromise</em> = <em>xrSession</em>.requestReferenceSpace(<em>referenceSpaceType</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>type</code></dt>
 <dd>A {{domxref("DOMString")}} specifying the type of reference space for which an instance is to be returned. The string must be one of those found in the {{domxref("XRReferenceSpaceType")}} enumerated type.</dd>
</dl>

<p>{{page("/en-US/docs/Web/API/XRReferenceSpaceType", "Values")}}</p>

<h3 id="Return_value">Return value</h3>

<p>A {{JSxRef("Promise")}} that resolves with an {{DOMxRef("XRReferenceSpace")}} object.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>Rather than throwing true exceptions, <code>requestReferenceSpace()</code> rejects the returned promise with a {{domxref("DOMException")}} whose name is found in the list below:</p>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>The requested reference space is not supported.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrsession-requestreferencespace','requestReferenceSpace()')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRSession.requestReferenceSpace")}}</p>
